# SoVRMLSphereSensor Class Reference
[VRML97 classes]

`#include <Inventor/VRMLnodes/SoVRMLSphereSensor>`

Inheritance diagram for SoVRMLSphereSensor:

List of all members.

## Detailed Description

The SoVRMLSphereSensor class maps pointer motion into rotations on a sphere.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

      SphereSensor {
        exposedField SFBool     autoOffset        TRUE
        exposedField SFBool     enabled           TRUE
        exposedField SFRotation offset            0 1 0 0  # [-1,1],(-,)
        eventOut     SFBool     isActive
        eventOut     SFRotation rotation_changed
        eventOut     SFVec3f    trackPoint_changed
      }

The SphereSensor node maps pointing device motion into spherical rotation about the origin of the local coordinate system. The SphereSensor node uses the descendent geometry of its parent node to determine whether it is liable to generate events.

The enabled exposed field enables and disables the SphereSensor node. If enabled is TRUE, the sensor reacts appropriately to user events. If enabled is FALSE, the sensor does not track user input or send events. If enabled receives a FALSE event and isActive is TRUE, the sensor becomes disabled and deactivated, and outputs an isActive FALSE event. If enabled receives a TRUE event the sensor is enabled and ready for user activation.

The SphereSensor node generates events when the pointing device is activated while the pointer is indicating any descendent geometry nodes of the sensor's parent group. See 4.6.7.5, Activating and manipulating sensors (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.7.5>), for details on using the pointing device to activate the SphereSensor.

Upon activation of the pointing device (e.g., mouse button down) over the sensor's geometry, an isActive TRUE event is sent. The vector defined by the initial point of intersection on the SphereSensor's geometry and the local origin determines the radius of the sphere that is used to map subsequent pointing device motion while dragging. The virtual sphere defined by this radius and the local origin at the time of activation is used to interpret subsequent pointing device motion and is not affected by any changes to the sensor's coordinate system while the sensor is active.

For each position of the bearing, a rotation_changed event is sent which corresponds to the sum of the relative rotation from the original intersection point plus the offset value. trackPoint_changed events reflect the unclamped drag position on the surface of this sphere. When the pointing device is deactivated and autoOffset is TRUE, offset is set to the last rotation_changed value and an offset_changed event is generated. See 4.6.7.4, Drag sensors (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.7.4>), for more details.

When the sensor generates an isActive TRUE event, it grabs all further motion events from the pointing device until it is released and generates an isActive FALSE event (other pointing-device sensors shall not generate events during this time). Motion of the pointing device while isActive is TRUE is termed a "drag". If a 2D pointing device is in use, isActive events will typically reflect the state of the primary button associated with the device (i.e., isActive is TRUE when the primary button is pressed and FALSE when it is released). If a 3D pointing device (e.g., wand) is in use, isActive events will typically reflect whether the pointer is within (or in contact with) the sensor's geometry.

While the pointing device is activated, trackPoint_changed and rotation_changed events are output. trackPoint_changed events represent the unclamped intersection points on the surface of the invisible sphere. If the pointing device is dragged off the sphere while activated, browsers may interpret this in a variety of ways (e.g., clamp all values to the sphere or continue to rotate as the point is dragged away from the sphere).

Each movement of the pointing device while isActive is TRUE generates trackPoint_changed and rotation_changed events. Further information about this behaviour can be found in 4.6.7.3 (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.7.3>), Pointing-device sensors, 4.6.7.4, Drag sensors (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.7.4>), and 4.6.7.5, Activating and manipulating sensors (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.7.5>).

## Public Member Functions

| SoVRMLSphereSensor (void)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFRotation | offset
SoSFRotation | rotation_changed

## Protected Member Functions

virtual SbBool | dragStart (void)
virtual void | drag (void)
virtual void | dragFinish (void)
virtual | ~SoVRMLSphereSensor ()

## Constructor & Destructor Documentation

SoVRMLSphereSensor::SoVRMLSphereSensor | ( | void |  | ) |

| Constructor.

SoVRMLSphereSensor::~SoVRMLSphereSensor | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVRMLSphereSensor::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoVRMLDragSensor.

SbBool SoVRMLSphereSensor::dragStart | ( | void |  | ) | `[protected, virtual]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when dragger is selected (picked) by the user. Implements SoVRMLDragSensor.

void SoVRMLSphereSensor::drag | ( | void |  | ) | `[protected, virtual]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when user drags the mouse after picking the dragger. Implements SoVRMLDragSensor.

void SoVRMLSphereSensor::dragFinish | ( | void |  | ) | `[protected, virtual]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when mouse button is released after picking and interacting with the dragger. Implements SoVRMLDragSensor.

## Member Data Documentation

SoSFRotation SoVRMLSphereSensor::offset

| The sensor rotation value.

SoSFRotation SoVRMLSphereSensor::rotation_changed

| An eventOut that is updated during interaction. Holds the differense between the current rotation and the sensor rotation value.

The documentation for this class was generated from the following files:

- SoVRMLSphereSensor.h
- SphereSensor.cpp